<main data-component="continuum">
    <form [formGroup]="continuumForm">
        <div class="grid-container">
            <div class="grid-item">
                <article>
                  <mat-form-field title="Select a method of supply">
                        <mat-label>{{fieldSupplied.title}}</mat-label>
                        <mat-select formControlName="{{fieldSupplied.field}}"
                                    required
                                    (selectionChange)="suppliedChangedContPanel($event.value)">
                            <ng-container *ngFor="let item of fieldSupplied.defaultValue">
                                <mat-option [value]="item.value">{{item.displayValue}}</mat-option>
                            </ng-container>
                        </mat-select>
                    </mat-form-field>
                  <article style="width: 50%;" class="field-with-units" *ngIf="getFieldSupplied(fieldSupplied.field) ==='IntegrationTime'">
                    <mat-form-field style="width: 100%;" floatLabel="always" title={{fieldIntegrationTime.description}}>
                        <mat-label>{{fieldIntegrationTime.title}}</mat-label>
                        <input matInput placeholder="{{fieldIntegrationTime.placeholder}}"
                                        formControlName="{{fieldIntegrationTime.field}}"
                                        (ngModelChange)="paramChangeContPanel()">
                        <mat-error id="errIntegrationTime">
                          {{getErrorMessage('fieldIntegrationTime')}}
                        </mat-error>
                    </mat-form-field>
                    <span class="units-button">
                      <button mat-button style="text-transform: none; width:10%" [matMenuTriggerFor]="integrationTimeSelection"
                          type="button" matTooltip="Expand to change time operator" matTooltipPosition="left"
                          disabled="{{continuumForm.get('fieldIntegrationTime')!.disabled}}">
                          <span class="button-text">
                              {{ selectedIntegrationTime.value }}
                              <fa-icon class="icon" [icon]="faCaretDown" aria-hidden="false"></fa-icon>
                          </span>
                      </button>
                      <mat-menu #integrationTimeSelection="matMenu">
                          <ng-container *ngFor="let time of defaultTimeDropdownOptions">
                              <button mat-menu-item (click)="selectIntegrationTime(time)">
                                  {{ time.value }}</button>
                          </ng-container>
                      </mat-menu>
                      </span>
                  </article>
                  <article style="width: 50%;" class="field-with-units" *ngIf="getFieldSupplied(fieldSensitivity.field) ==='Sensitivity'">
                    <mat-form-field style="width: 100%" floatLabel="always" title={{fieldSensitivity.description}}>
                        <mat-label>{{fieldSensitivity.title}}</mat-label>
                        <input matInput placeholder="{{fieldSensitivity.placeholder}}"
                                        formControlName="{{fieldSensitivity.field}}"
                                        (ngModelChange)="paramChangeContPanel()">

                        <mat-error id="errSensitivity">
                          {{getErrorMessage('fieldSensitivity')}}
                        </mat-error>
                    </mat-form-field>
                    <span class="units-button">
                            <button mat-button style="text-transform: none;" [matMenuTriggerFor]="sensitivitySelection"
                                type="button" matTooltip="Expand to change sensitivity operator" matTooltipPosition="left"
                                disabled="{{continuumForm.get('fieldSensitivity')!.disabled}}">
                                <span class="button-text">
                                    {{ selectedSensitivity.value }}
                                    <fa-icon class="icon" [icon]="faCaretDown" aria-hidden="false"></fa-icon>
                                </span>
                            </button>
                            <mat-menu #sensitivitySelection="matMenu">
                                <ng-container *ngFor="let sensitivity of defaultSensitivityDropdownOptions">
                                    <button mat-menu-item (click)="selectSensitivity(sensitivity)">
                                        {{ sensitivity.value }}</button>
                                </ng-container>
                            </mat-menu>
                        </span>
                  </article>
                </article>
                <div class="field-with-units">
                  <mat-form-field floatLabel="always" title="{{fieldCentralFrequency.description}}">
                    <mat-label>{{fieldCentralFrequency.title}}</mat-label>
                    <input matInput placeholder="{{fieldCentralFrequency.placeholder}}"
                                    formControlName="{{fieldCentralFrequency.field}}"
                                    required
                                    (ngModelChange)="freqParamChange()">
                    <mat-error id="errCentralFrequency">
                        {{getErrorMessage('fieldCentralFrequency')}}
                    </mat-error>
                </mat-form-field>
                  <span class="units-button">
                        <button mat-button style="text-transform: none;" [matMenuTriggerFor]="centralFreqSelection"
                            type="button" matTooltip="Expand to change centralFrequency operator" matTooltipPosition="left">
                            <span class="button-text">
                                {{ selectedCentralFrequency.value }}
                                <fa-icon class="icon" [icon]="faCaretDown" aria-hidden="false"></fa-icon>
                            </span>
                        </button>
                        <mat-menu #centralFreqSelection="matMenu">
                            <ng-container *ngFor="let frequency of defaultFrequencyDropdownOptions">
                                <button mat-menu-item (click)="selectCentralFrequency(frequency)">
                                    {{ frequency.value }}</button>
                            </ng-container>
                        </mat-menu>
                    </span>
                </div>
                <div class="field-with-units">
                  <mat-form-field floatLabel="always" title={{fieldBandwidth.description}}>
                    <mat-label>{{fieldBandwidth.title}}</mat-label>
                    <input matInput placeholder="{{fieldBandwidth.placeholder}}"
                           formControlName="{{fieldBandwidth.field}}"
                           (ngModelChange)="continuumBandwidthChanged()">
                    <mat-error id="errBandwidth">
                      {{getErrorMessage('fieldBandwidth')}}
                    </mat-error>
                  </mat-form-field>
                  <span class="units-button">
                      <button mat-button style="text-transform: none;" [matMenuTriggerFor]="bandwidthSelection"
                          type="button" matTooltip="Expand to change bandwidth operator" matTooltipPosition="left">
                          <span class="button-text">
                              {{ selectedBandwidth.value }}
                              <fa-icon class="icon" [icon]="faCaretDown" aria-hidden="false"></fa-icon>
                          </span>
                      </button>
                      <mat-menu #bandwidthSelection="matMenu">
                          <ng-container *ngFor="let frequency of defaultFrequencyDropdownOptions">
                              <button mat-menu-item (click)="selectBandwidth(frequency)">
                                  {{ frequency.value }}</button>
                          </ng-container>
                      </mat-menu>
                  </span>
                </div>
                <mat-form-field floatLabel="always" title={{fieldNoOfSubBands.description}}>
                    <mat-label>{{fieldNoOfSubBands.title}}</mat-label>
                    <input
                      type="number"
                      min="{{fieldNoOfSubBands.defaultValue.min}}"
                      max="{{fieldNoOfSubBands.defaultValue.max}}"
                      matInput placeholder="{{fieldNoOfSubBands.placeholder}}"
                      formControlName="{{fieldNoOfSubBands.field}}"
                      (ngModelChange)="paramChangeContPanel()"
                    required>
                    <mat-error id="errNoOfSubBands">
                      {{getErrorMessage('fieldNoOfSubBands')}}
                    </mat-error>
                </mat-form-field>

                <mat-form-field floatLabel="always" class="resolution-display"
                                title={{fieldResolution.description}}>
                    <mat-label>{{fieldResolution.title}}</mat-label>
                    <input matInput formControlName="{{fieldResolution.field}}" readonly style="width: 70px;">
                    <span>{{getResolutionDisplayValue(fieldResolution.defaultValue)}}</span>
                    <mat-error id="errResolution">
                      {{getErrorMessage('fieldResolution')}}
                    </mat-error>
                </mat-form-field>

                <article>
                    <mat-form-field floatLabel="always" title={{fieldSpectralAveraging.description}}>
                        <mat-label>{{fieldSpectralAveraging.title}}</mat-label>
                        <mat-select formControlName="{{fieldSpectralAveraging.field}}"
                            (selectionChange)="spectralAveragingChanged($event.value)"
                            required>
                            <ng-container *ngFor="let item of spectralAveragingOptions">
                                <mat-option [value]="item.value">{{item.value}}</mat-option>
                            </ng-container>
                        </mat-select>
                        <mat-error>{{getErrorMessage('fieldSpectralAveraging')}}</mat-error>
                    </mat-form-field>

                    <mat-form-field floatLabel="always" title={{fieldEffectiveResolution.description}}>
                        <mat-label>{{fieldEffectiveResolution.title}}</mat-label>
                        <input matInput placeholder="{{fieldEffectiveResolution.placeholder}}"
                            formControlName="{{fieldEffectiveResolution.field}}" readonly>
                        <mat-error id="errEffectiveResolution">
                          {{getErrorMessage('fieldEffectiveResolution')}}
                        </mat-error>
                    </mat-form-field>
                </article>

                <article style={{imageWeightingStyle}}>
                    <mat-form-field title={{fieldImageWeighting.description}}>
                        <mat-label>{{fieldImageWeighting.title}}</mat-label>
                        <mat-select formControlName="{{fieldImageWeighting.field}}"
                                    required
                                    (selectionChange)="weightingChanged($event.value)">
                            <ng-container *ngFor="let item of fieldImageWeighting.defaultValue">
                                <mat-option [value]="item.value">{{item.option}}</mat-option>
                            </ng-container>
                        </mat-select>
                    </mat-form-field>

                    <mat-form-field  *ngIf="showRobustness" style="margin-right: 10px;"
                                    title={{fieldRobust.description}}>
                        <mat-label>{{fieldRobust.title}}</mat-label>
                        <mat-select required formControlName="{{fieldRobust.field}}" (selectionChange)="paramChangeContPanel()">
                            <ng-container *ngFor="let robustness of fieldRobust.defaultValue">
                                <mat-option [value]="robustness">{{robustness}}</mat-option>
                            </ng-container>
                        </mat-select>
                    </mat-form-field>

                    <mat-form-field floatLabel="always" title={{fieldTapering.description}}>
                        <mat-label>{{fieldTapering.title}}</mat-label>
                        <mat-select formControlName="{{fieldTapering.field}}" (selectionChange)="paramChangeContPanel()">
                            <ng-container *ngFor="let taper of getTaperValues(); let i = index">
                                <mat-option [value]="taper">{{midCalcService.getDisplayedTaper(taper, getScaledFrequency())}}{{i !== 0 ? '"' : ''}}
                                </mat-option>
                            </ng-container>
                        </mat-select>
                    </mat-form-field>
                </article>
            </div>
            <div class="grid-item">
                <app-continuum-results [nSubBands]="continuumForm.get('fieldNoOfSubBands')?.value" [continuumResults]="continuumResults"></app-continuum-results>
            </div>
        </div>
    </form>
</main>
